package jp.co.mki.guide.common;

import java.util.Date;
import jp.co.mki.guide.common.DataBeanInterface;

/**
 * Base Data Bean for Blast
 * @author Y.KIDO
 * @version 0.0.1
 */
public class BaseJobBean extends BaseDataBean {
    /** Sequence Text */
    private String seqText = "";

    /**
     * Sequence Text setter
     * @param value Sequence Text
     */
    public void setSeqText(String value){ this.seqText = value; }

    /**
     * Sequence Text getter
     * @return String Sequence Text
     */
    public String getSeqText() { return this.seqText; }

    /** Upload Sequence Type */
    private String seqLoadType = "";

    /**
     * Upload Sequence Type setter
     * @param value Upload Sequence Type
     */
    public void setSeqLoadType(String value) { this.seqLoadType = value; }

    /**
     * Upload Sequence Type getter
     * @return String Upload Sequence Type
     */
    public String getSeqLoadType() { return this.seqLoadType; }

    /** Sequence File Name */
    private String seqFileName = "";

    /**
     * Sequence File Name setter
     * @param value Sequence File Name
     */
    public void setSeqFileName(String value) { this.seqFileName = value; }

    /**
     * Sequence File Name getter
     * @param String Sequence File Name
     */
    public String getSeqFileName() { return this.seqFileName; }


    private String acceptDate = "";
//    private Date acceptDate = "";
    public void setAcceptDate(String value) { this.acceptDate = value; }
    public String getAcceptDate() { return this.acceptDate; }

    private String finishDate = "";
    public void setFinishDate(String value) { this.finishDate = value; }
    public String getFinishDate() { return this.finishDate; }

    private String resultFileName = "";
    public void setResultFileName(String value) { this.resultFileName = value; }
    public String getResultFileName() { return this.resultFileName; }

    private String jobId = "";
    public void setJobID(String value) { this.jobId = value; }
    public String getJobID() { return this.jobId; }

    private String jobStatus = "";
    public void setJobStatus(String value) {
        String tmp = this.jobStatus;
        this.jobStatus = value;
        if ( tmp != null && !tmp.equals("") )
            JobDatabase.write();
    }
    public String getJobStatus() { return this.jobStatus; }

    public String getResultFileNameForHtml() {
        String ret = this.getResultFileName();
        if ( ret.lastIndexOf("/") >= 0 )
            ret = ret.substring(ret.lastIndexOf("/") + 1);

        if ( this.getJobStatus() != null && this.getJobStatus().equals("finish") )
            ret = "<a href=\"/guide/" + ret + "\">" + ret + "</a>";

        return ret;
    }

    public String getResultFileNameForLocal() {
        String resultFile = this.getResultFileName();
        if ( resultFile.lastIndexOf("/") >= 0 )
            resultFile = resultFile.substring( resultFile.lastIndexOf("/") );

        return CommonProperties.getProperty("LOCAL_WORK_DIR") + resultFile;
    }
}
