package jp.co.mki.guide.common;

import java.util.Set;
import java.util.Vector;
import java.util.HashSet;
import java.util.Collections;
import java.util.Iterator;

/**
 * Common Hosts Manager
 */
public final class CommonHosts {

    /** myself object holder */
    private static CommonHosts hosts = new CommonHosts();

    /** Hosts Set object holder  */
    private Set hostSet = Collections.synchronizedSet(new HashSet());

    /** index */
    private int index = 0;

    /**
     */
    private CommonHosts() {
        String[] array = CommonProperties.getPropertyArray("HOSTS");
        //String[] array = new String[] { "awaji.ais.cmc.osaka-u.ac.jp", "bg02n000e00.hpc.cmc.osaka-u.ac.jp", };
        for ( int i = 0; i < array.length; i++ )
            hostSet.add(array[i]);
    }

    /**
     * Get Hosts Vector
     * @return Vector host list
     */
    public static Vector getHostsVector() {
        return new Vector(hosts.hostSet);
    }

    /**
     * Get Hosts array
     * @return String[] host array
     */
    public static String[] getHostsArray() {
        Iterator it = hosts.hostSet.iterator();
        String[] ret = new String[hosts.hostSet.size()];
        for ( int i = 0; it.hasNext(); i++ ) {
            ret[i] = (String) it.next();
        }
        return ret;
    }

    /**
     * Add host
     * @param hostName
     */
    public static void addHost(String hostName) {
        if ( !hosts.hostSet.contains(hostName) )
            hosts.hostSet.add(hostName);
    }

    /**
     * Delete host
     * @param hostName
     */
    public static void removeHost(String hostName) {
        if ( !hosts.hostSet.contains(hostName) )
            hosts.hostSet.remove(hostName);
    }

    public static void setSelectedIndex(int index) {
        if ( 0 <= index &&  index < hosts.hostSet.size() )
            hosts.index = index;
    }

    public static String getSelectedHost() {
        if ( 0 <= hosts.index && hosts.index < hosts.hostSet.size() )
            return hosts.getHostsArray()[hosts.index];
        return "";
    }

    public static void setSelectedHost(String hostName) {
        String[] array = hosts.getHostsArray();
        for ( int i = 0; i < array.length; i++ ) {
            if ( array[i].equals(hostName) ) {
                CommonHosts.setSelectedIndex(i);
                break;
            }
        }
    }
}