package jp.co.mki.guide.common;

import java.io.*;
import java.util.*;

public class CommonProperties {
    private static ResourceBundle prop = ResourceBundle.getBundle("guide");
    private static Map hostProps = Collections.synchronizedMap( new HostMap() );

    public static Map getHostProperties(String hostName) {
        return (Map) hostProps.get(hostName);
    }

    public static String getProperty(String name) {
        String tmp = "";
        try {
            tmp = prop.getString(name);
        } catch ( java.util.MissingResourceException ex ) {
            System.err.println( "CommonProperties:[" + name + "]");
            // get comhostsproperties
            Properties host = (Properties) hostProps.get( CommonHosts.getSelectedHost() );
            tmp = host.getProperty(name);
            if ( tmp == null ) {
                System.err.println("CommonProperties:[" + name + "] is not found.");
                tmp = "";
            }
        }
        return tmp;
    }

    public static String[] getPropertyArray(String name) {
        List propList = new ArrayList();
        for ( int i = 0; true; i++ ) {
            try {
                String tmp = getProperty(name + "." + i);
                if ( tmp != null && !tmp.equals("EOA") )
                    propList.add(tmp);
                else
                    break;
            } catch (java.util.MissingResourceException ex ) {
                break;
            }
        }

        String[] res;
        if ( propList.size() <= 0 )
            res = new String[0];
        else {
            res = new String[ propList.size() ];
            Iterator it = propList.iterator();
            for ( int i = 0; it.hasNext(); i++ )
                res[i] = (String) it.next();
        }

        return res;
    }
}
