package jp.co.mki.guide.common;

import org.globus.io.ftp.FTPClient;
import org.globus.io.ftp.GridFTPClient;
import org.globus.security.GlobusProxy;

/**
 * @author Y.KIDO
 * @version 0.0.1
 */
public class FtpClientFactory {

    private FtpClientFactory() {}

    public static final FTPClient createFTPClient(String hostName, GlobusProxy proxy) {
        //make ftp client
        FTPClient ftpClient = null;
        try {
            try {
                ftpClient = new GridFTPClient( hostName, Integer.parseInt( CommonProperties.getProperty("GRID_FTP_PORT")));
                ((GridFTPClient) ftpClient).authenticate( proxy );
            } catch ( Exception ex ) {
                ftpClient = new FTPClient( hostName, Integer.parseInt( CommonProperties.getProperty("FTP_PORT")) );
                ftpClient.authenticate(
                        CommonProperties.getProperty("FTP_USER"),
                        CommonProperties.getProperty("FTP_PASSWD")
                        );
            }
        } catch ( Exception ex ) {
            ex.printStackTrace();
        }

        return ftpClient;
    }

    public static final void releaseFTPClient(FTPClient ftpClient) {
        try {
            ftpClient.disconnect();
            ftpClient.close();
        } catch ( Exception ex ) {
            ex.printStackTrace();
        }
    }
}