package jp.co.mki.guide.model;

import java.util.*;
import javax.servlet.http.*;
import org.globus.security.*;
import org.globus.myproxy.*;
import jp.co.mki.guide.servlet.*;
import jp.co.mki.guide.bean.*;
import jp.co.mki.guide.common.*;

/**
 * Blast Model Class
 *  - GUIDE on WEB SYSTEM -
 * @author Y.KIDO
 * @version 0.0.1
 */
public class ProxyModel extends BaseServlet {

    public void execute() throws Exception {
        LoginBean bean = new LoginBean();
        super.paramToDataBean(bean);

        // view Login Page
        if ( bean.getFunction() == null || bean.getFunction().equals("") ) {
            req.setAttribute("loginBean", bean);
            req.getRequestDispatcher("./login.jsp").forward(super.req, super.res);
            return;
        }

        // Log out
        if ( bean.getFunction().equals("LOGOUT") ) {
            req.setAttribute("loginBean", new LoginBean() );
            req.getSession().removeAttribute("PROXY");
            req.getSession().removeAttribute("USER_NAME");
            req.getRequestDispatcher("./login.jsp").forward(super.req, super.res);
            return;
        }

        // Get MyProxy Server Object
        MyProxy myProxy = new MyProxy(
                CommonProperties.getProperty("MYPROXY_SERVER_NAME"),
                Integer.parseInt( CommonProperties.getProperty("MYPROXY_SERVER_PORT") )
            );
        //myProxy.setAuthorization( new Authorization());

        try {
            // Get proxy from MyProxy Server
            GlobusProxy proxy = myProxy.get(
                    //GlobusProxy.getDefaultUserProxy(),
                    null,
                    bean.getUserName(),
                    bean.getPassPhrase(),
                    Integer.parseInt( CommonProperties.getProperty("LIFETIME_SECONDS") )
                );

            // Set proxy to session when Success got proxy
            HttpSession session = req.getSession(true);
            session.setAttribute("PROXY", proxy);
            session.setAttribute("USER_NAME", bean.getUserName() );
            GlobusProxy.setDefaultUserProxy(proxy);
        } catch ( Exception ex ) {
            ex.printStackTrace();
            bean.setErrorMessage("Please reinput. Try again.");
            req.setAttribute("loginBean", bean);
            req.getRequestDispatcher("./login.jsp").forward(super.req, super.res);
            return;
        }

        // if Success
        // forward NextPage
        // req.setAttribute("userName", bean.getUserName());
        req.getRequestDispatcher("./main.jsp").forward(super.req, super.res);
    }
}