package jp.co.mki.guide.servlet;

import javax.servlet.http.*;
import org.globus.io.ftp.FTPClient;
import org.globus.io.ftp.GridFTPClient;
import org.globus.security.GlobusProxy;
import jp.co.mki.guide.bean.LoginBean;
import jp.co.mki.guide.common.*;

/**
 * @author Y.KIDO
 * @version 0.0.1
 */
public abstract class AuthenticationServlet extends BaseServlet {
    protected final boolean authoentictaion(HttpServletRequest request, HttpServletResponse response) {
        if ( !this.isProxy(request) ) {
            LoginBean bean = new LoginBean();
            request.setAttribute("dataBean", bean);
            try {
                bean.setErrorMessage("Your account invalied.");
                request.getRequestDispatcher("./error.jsp").forward(request, response);
            } catch ( Exception ex ) {
                ex.printStackTrace();
            }
            return false;
        } else {
            return true;
        }
    }

    protected void paramToDataBean(DataBeanInterface dataBean) {
        super.paramToDataBean(dataBean);

        String usrName = (String) super.req.getSession().getAttribute("USER_NAME");
        if (  usrName != null && !usrName.equals("") &&
              dataBean instanceof BaseDataBean ) {
            ((BaseDataBean) dataBean).setUserName(usrName);
        }
    }

    protected void multiPartToDataBean(DataBeanInterface dataBean) {
        super.multiPartToDataBean(dataBean);
        String usrName = (String) super.req.getSession().getAttribute("USER_NAME");
        if (  usrName != null && !usrName.equals("") &&
              dataBean instanceof BaseDataBean ) {
            ((BaseDataBean) dataBean).setUserName(usrName);
        }
    }

    private final boolean isProxy(HttpServletRequest req) {
        Object obj = req.getSession().getAttribute("PROXY");
        if ( obj != null && obj instanceof org.globus.security.GlobusProxy )
            return true;
        else
            return false;
    }

    protected FTPClient createFTPClient(String hostName) {
        //make ftp client
        FTPClient ftpClient = null;
        try {
            try {
                ftpClient = new GridFTPClient( hostName, Integer.parseInt( CommonProperties.getProperty("GRID_FTP_PORT")));
                ((GridFTPClient) ftpClient).authenticate((GlobusProxy) req.getSession().getAttribute("PROXY") );
            } catch ( Exception ex ) {
                ftpClient = new FTPClient( hostName, Integer.parseInt( CommonProperties.getProperty("FTP_PORT")) );
                ftpClient.authenticate(
                        CommonProperties.getProperty("FTP_USER"),
                        CommonProperties.getProperty("FTP_PASSWD")
                        );
            }
        } catch ( Exception ex ) {
            ex.printStackTrace();
        }

        return ftpClient;
    }

}