package jp.co.mki.guide.servlet;

import java.util.Map;
import java.util.Hashtable;
import java.util.ResourceBundle;
import java.util.StringTokenizer;
import java.lang.reflect.Method;
import javax.servlet.http.*;
import javax.servlet.ServletInputStream;
import jp.co.mki.guide.common.*;

/**
 * Base Controller Servlet
 *  - GUIDE on WEB SYSTEM -
 * @author Y.KIDO
 * @version 0.0.1
 */
public abstract class BaseServlet extends HttpServlet {
    protected HttpServletRequest req;
    protected HttpServletResponse res;
    //protected ResourceBundle prop = null;

    public void doGet(HttpServletRequest request, HttpServletResponse response) {
        if ( authoentictaion(request, response ) )
            control(request, response);
    }

    public void doPost(HttpServletRequest request, HttpServletResponse response) {
        if ( authoentictaion(request, response ) )
            control(request, response);
    }

    protected boolean authoentictaion(HttpServletRequest request, HttpServletResponse response) {
        return true;
    }

    private final void control(HttpServletRequest req, HttpServletResponse res) {

        this.req = req;
        this.res = res;

        // read properties file
        //if ( this.prop == null)
        //    this.prop = ResourceBundle.getBundle("guide");

        // get running job list
        //if ( this.req.getSession(true).getAttribute("JOB_LIST") == null )
        //    this.req.getSession().setAttribute("JOB_LIST", new java.util.Vector() );
        try {
            this.execute();
        } catch ( Exception ex ) {
            ex.printStackTrace();
            return;
        }
    }

    public abstract void execute() throws Exception;

    protected void paramToDataBean(DataBeanInterface dataBean) {
        System.err.println("paramToDataBean");
        // Get Param Name's
        java.util.Enumeration enum = req.getParameterNames();

        // loop
        while ( enum.hasMoreElements() ) {
            // Get Param Name
            String name = (String) enum.nextElement();
            // Get Param Value
            String value = req.getParameter(name);
            System.err.println("[" + name + "]=[" + value + "]");
            try {
                // Get setter method object
                Method setMethod = dataBean.getClass().getMethod("set" + name , new Class[] { String.class, });

                // Call setter
                setMethod.invoke(dataBean, new Object[] { value, });
            } catch ( Exception ex ) {
                // Exception is usefull
                System.err.println( ex );
            }
        }
        // 2003.06.21 Y.Kido add.
        //((BaseDataBean) dataBean).setTitle( CommonProperties.getProperty("TITLE") );
        //((BaseDataBean) dataBean).setSubTitle( CommonProperties.getProperty("SUB_TITLE") );
    }

    /**
     * make Uniq String
     * <pre>Total seconds from 01.01.70</pre>
     * @return String maked uniq string
     */
    protected final String makeUniqueString () {
        return Long.toString(new java.util.Date().getTime());
    }

    /**
     * This Class Name getter
     * @return String This Class Name
     */
    protected final String getClassName() {
        return getClassName(this);
    }

    /**
     * Class Name getter
     * @param obj Object
     * @return String Class Name
     */
    protected final String getClassName(Object obj) {
        String className = obj.getClass().getName();
        return className.substring(className.lastIndexOf('.') + 1);
    }


    protected void multiPartToDataBean(DataBeanInterface dataBean) {
        try {
            Map params = this.parseMultipart(this.req);
            java.util.Iterator keys = params.keySet().iterator();
            while ( keys.hasNext() ) {
                String name = (String) keys.next();
                String value = (String) params.get(name);
                System.err.println("multiPart [" + name + "][" + value + "]");
                try {
                    // Get setter method object
                    Method setMethod = dataBean.getClass().getMethod("set" + name , new Class[] { String.class, });
                    // Call setter
                    setMethod.invoke(dataBean, new Object[] { value, });
                } catch ( Exception ex) {
                    System.err.println( ex );
                }
            }
        } catch ( Exception ex ) {
            ex.printStackTrace();
        }
    }

    protected final Map parseMultipart(HttpServletRequest request) throws java.io.IOException {
        Map table = new Hashtable();
        if ( request == null || request.getContentType() == null ) {
            return table;
        }

        java.io.BufferedReader reader = request.getReader();
        String line = null;
        String key = null;
        String value = null;
        System.err.println("\n");
        boolean firstFlag = true;
        while ( (line = reader.readLine()) != null ) {
            //System.err.println("[" + line + "]");
            if ( line.startsWith("Content-Disposition:") ) {
                if ( firstFlag ) {
                    firstFlag = false;
                    value = null;
                }
                StringTokenizer st = new StringTokenizer(line, "\"");
                st.nextToken();
                key = st.nextToken();
                line = reader.readLine();
                if ( !line.equals("") ) line = reader.readLine();
                line = reader.readLine();
            }

            if ( key != null &&
                 value != null &&
                 line.indexOf("-----------------------------") >= 0 ) {
                table.put(key, value);
                key = null;
                value = null;
                continue;
            }

            if ( value != null) value = value + "\n" + line;
            else value = line;

        }
/*
        int maxSize = 1024 * 10;
        byte[] buf = new byte[maxSize];
        //String line = new String();
        //String lower Line = new String();

        int len = -1;
        java.io.ByteArrayOutputStream stream = new java.io.ByteArrayOutputStream(maxSize);
        String name = null;

        System.err.println("vvvvv getInputStream() vvvvv");
        while( (len = in.readLine(buf, 0, maxSize)) != -1) {
            String line = new String(buf, 0, len -2);
            String lowerLine = line.toLowerCase();
            System.err.println(line);


            if ( lowerLine.startsWith("content-disposition") ) {
                int s0 = lowerLine.indexOf("name=\"");
                int e0 = lowerLine.indexOf("\"", s0 + 7);
                if ( s0 != -1 && e1 != -1 ) {

                } //if
            } // if

        } // while*/
        System.err.println("^^^^^ getInputStream() ^^^^^");

        return table;
    }
}